require 'covere.stuff.GUI'
require 'covere.stuff.AnAL'

local menu = {}
menu.__index = menu

function menu:init()
    self:setupThing()
    self:setupListener()
end

function menu:setupThing()
    self.gui = GUI.new()
    self.gui:addButton('Play', 380, 200, 200, 60, function(btn) self:toPlayScene() end)
    self.gui:addButton('Quit', 380, 500, 200, 60, function(btn) self:toQuitScene() end)

    self.explosion = Thing.new()
    self.explosion.anim = newAnimation(content.images.explosion, 80, 80, 0.1, 0)
    local anim = self.explosion.anim
    anim:setMode('once')
    anim:stop()
    self.explosion.draw = function ()
        if anim.playing then
            anim:draw(love.mouse.getX() - 40, love.mouse.getY() - 40)
        end
    end
    self.explosion.always = function ()
        anim:update(dt)
    end
end

function menu:setupListener()
end

function menu:toPlayScene()
    self.explosion:seq(function ()
        local anim = self.explosion.anim
        anim:play()
        while anim.playing do yield() end
        director.changeScene('play')
    end)
end

function menu:toQuitScene()
    --director.changeScene('quit')
    love.event.push('q')
end

director.addScene('menu', function () setmetatable({}, menu):init() end)