
AutoStorm = {}
AutoStorm.__index = AutoStorm

function AutoStorm.new(x, y, fallSpeed, lifeTime)
    local self = Item.new(x, y, fallSpeed, lifeTime):extend(AutoStorm)

    self.tags:add('autostorm')

    return self
end

function AutoStorm.getAll(...)
    return Thing.getAll('autostorm', ...)
end

function AutoStorm:draw()
    g.push()
    g.translate(self.x, self.y)
    g.scale(self.r/content.images.autostorm_r)
    g.setColor(50, 255, 255, 255*self.remainTime/self.lifeTime)
    g.draw(content.images.autostorm, -content.images.autostorm_hw, -content.images.autostorm_hh)
    g.pop()
end

function AutoStorm:active()
    Item.active(self)

    self:seq(function ()
        while true do
            local list = Thing.getAll('bulletstorm')

            for i, v in ipairs(list) do
                v:fire()
            end

            yield()
        end
    end)
end

function AutoStorm:deactive()
    Item.deactive(self)
end