require 'flatmoon.tweener'

Bomber = {}
Bomber.__index = Bomber

function Bomber.new(x, y, fallSpeed, lifeTime)
    local self = Item.new(x, y, fallSpeed, lifeTime):extend(Bomber)

    self.tags:add('bomber')

    self.lis1 = nil

    return self
end

function Bomber.getAll(...)
    return Thing.getAll('bomber', ...)
end

function Bomber:draw()
    g.push()
    g.translate(self.x, self.y)
    g.scale(self.r/content.images.bomber_r)
    g.setColor(50, 255, 255, 255*self.remainTime/self.lifeTime)
    g.draw(content.images.bomber, -content.images.bomber_hw, -content.images.bomber_hh)
    g.pop()
end

function Bomber:active()
    Item.active(self)

    self.lis1 = listener.add('keypressed', 'b', function ()
        local list = Enemy.getAll()
        for _, e in ipairs(list) do e:performDestroy() end

        list = Bullet.getAll()
        for _, b in ipairs(list) do b:performDestroy() end

        --effecting
        love.audio.newSource(content.sounds.bomber):play()
    end)
end

function Bomber:deactive()
    listener.remove2(self.lis1)
    Item.deactive(self)
end