
require 'covere.scenes.play.Bullet'

BulletStorm = {}
BulletStorm.__index = BulletStorm

function BulletStorm.new(kind, x, y, angle, r, damage)
    local self = Thing.new({'bulletstorm'}):extend(BulletStorm)

    self.kind = kind
    self.x = x
    self.y = y
    self.angle = angle
    self.r = 15
    self.damage = damage

    self.lifeTime = 5
    self.remainTime = self.lifeTime

    return self
end

function BulletStorm.getAll(...)
    return Thing.getAll('bulletstorm', ...)
end

function BulletStorm:draw()
    g.push()
    g.translate(self.x, self.y)
    g.scale(self.r/content.images.bulletstorm_r)
    g.rotate(self.angle)
    g.setColor(255, 255, 0, 255*self.remainTime/self.lifeTime)
    g.draw(content.images.bulletstorm, -content.images.bulletstorm_hw, -content.images.bulletstorm_hh)
    g.pop()
end

function BulletStorm:always()
    local mx, my = love.mouse.getX(), love.mouse.getY()
    local dist = math.sqrt(math.pow(self.x - mx, 2) + math.pow(self.y - my, 2))

    if dist <= self.r then
        self:fire()
    end

    self:processOut()
end

function BulletStorm:fire()
    --effecting
    love.audio.newSource(content.sounds.stormfire):play()

    for i = 1, 4, 1 do
        Bullet.new('enemy', self.x, self.y, self.angle + 2*math.pi*i/4, 700, self.damage, true)
    end

    self:destroy()
end

function BulletStorm:processOut()
    self.remainTime = self.remainTime - dt
    if self.remainTime <= 0 then
        self:destroy()
    end
end