require 'flatmoon.tweener'
require 'covere.stuff.AnAL'

Core = {}
Core.__index = Core

local instance = nil

function Core.new()
    if instance and instance:alive() then return instance end

    instance = Thing.new({'core'}):extend(Core)

    instance.x, instance.y = g.getWidth()/2, g.getHeight()/2
    instance.r = 25
    instance.anim = newAnimation(content.images.core, 50, 50, 0.15, 0)
    instance.anim:setMode('bounce')

    instance.maxR = 25

    instance.onDie = nil

    return instance
end

function Core.instance()
    assert(instance, 'instance expects new before')

    return instance
end

function Core:draw()
    if self.inHurt then
        g.setColor(255, 0, 0, 20)
        g.rectangle('fill', 0, 0, g.getWidth(), g.getHeight())
    end

    g.push()
    g.translate(self.x, self.y)
    g.scale(self.r/content.images.core_r)
    g.setColor(0, 250, 150, 200)
    --g.draw(content.images.core, -content.images.core_hw, -content.images.core_hh)
    self.anim:draw(-content.images.core_hw, -content.images.core_hh)
    g.pop()
end

function Core:always()
    self.anim:update(dt)
end

function Core:performHurt(amount)
    self:seq(function ()
        --effecting
        love.audio.newSource(content.sounds.corehurt):play()

        while self.inHurt do yield() end

        self.inHurt = true
        tweener.tween(self, 0.5, {r = self.r - amount}, nil, nil, function () return self.r > 0 end)
        self.inHurt = false

        if self.r <= 0 then
            self.r = 0
            self:performDestroy()
        end
    end)
end

function Core:performDestroy()
    if self.onDie then self.onDie() end
end