require 'flatmoon.tweener'

Item = {}
Item.__index = Item

function Item.getN()
    if Item.listn then
    else
        Item.listn = {}
    end

    for i, v in ipairs(Item.listn) do
        if v == false then
            Item.listn[i] = true
            return i
        end
    end

    table.insert(Item.listn, true)
    return #(Item.listn)
end

function Item.freeN(n)
    Item.listn[n] = false
end

function Item.new(x, y, fallSpeed, lifeTime)
    local self = Thing.new({'item'}):extend(Item)

    self.x, self.y = x, y
    self.r = 10
    self.n = Item.getN()
    self.fallSpeed = fallSpeed
    self.lifeTime = lifeTime
    self.remainTime = self.lifeTime

    return self
end

function Item.getAll(...)
    return Thing.getAll('item', ...)
end

function Item:draw()
    
end

function Item:always()
    if self:alive() then
        self:processMove()
        self:processOut()
    end
end

function Item:processMove()
    self.y = self.y + self.fallSpeed*dt
end

function Item:processOut()
    if self.y > g.getHeight() + self.r then
        self:destroy()
    end
end

function Item:doActive()
    self:markAsDestroyed()

    --local ex = 960 - (10 + 2*self.r)*self.n
    --local ey = 640 - 10 - self.r
    local ex = 960 - 10 - self.r
    local ey = 640 - (10 + 2*self.r)*self.n

    --effecting
    love.audio.newSource(content.sounds.collected):play()

    self:seq(function ()
        tweener.tween(self, 0.5, {x = ex, y = ey}, nil)

        --life
        tweener.tween(self, self.lifeTime, {remainTime = 0})

        Item.freeN(self.n)
        self:deactive()
    end)
end

function Item:active()
    self:doActive()
end

function Item:deactive()
    self:destroy()
end

function Item:onDestroy()
    Item.freeN(self.n)
end