require 'flatmoon.tweener'

Recover = {}
Recover.__index = Recover

function Recover.new(x, y, fallSpeed, lifeTime)
    local self = Item.new(x, y, fallSpeed, lifeTime):extend(Recover)

    self.tags:add('recover')

    self.recoverySpeed = 2 -- radius / second

    return self
end

function Recover.getAll(...)
    return Thing.getAll('recover', ...)
end

function Recover:draw()
    g.push()
    g.translate(self.x, self.y)
    g.scale(self.r/content.images.recover_r)
    g.setColor(50, 255, 255, 255*self.remainTime/self.lifeTime)
    g.draw(content.images.recover, -content.images.recover_hw, -content.images.recover_hh)
    g.pop()
end

function Recover:active()
    Item.active(self)

    local core = Core.instance()
    self:seq(function ()
        while true do
            core.r = core.r + self.recoverySpeed*dt
            if core.r > core.maxR then
                core.r = core.maxR
            end
            
            yield()
        end
    end)
end

function Recover:deactive()
    Item.deactive(self)
end