
SlowMotion = {}
SlowMotion.__index = SlowMotion

local instance = nil

function SlowMotion.new()
    local self = Thing.new({'slowmotion'}):extend(SlowMotion)

    self.maxTime = 5
    self.restoreSpeed = 5/20 -- second/second
    self.timeFactor = 0.3

    self.state = 'idle'
    self.remainTime = self.maxTime

    local lis1 = listener.add('keypressed', ' ', function () self:toggle() end)
    self.onDestroy = function (self)
        flatmoon.engine.dtfactor = 1 --set to default
        listener.remove2(lis1)
    end

    return self
end

function SlowMotion.instance(...)
    assert(instance, 'instance expects new before')

    return instance
end

function SlowMotion:draw()
    if self.state == 'active' then
        g.setColor(254, 210, 130, 50 + math.random(20)) -- some effect at random
        g.rectangle('fill', 0, 0, g.getWidth(), g.getHeight())

        --setcolor for draw below
        g.setColor(255, 0, 255, 200)
    else
        g.setColor(254, 210, 130, 150)
    end

    g.push()
    g.translate(480, 600)
    g.scale(self.remainTime/self.maxTime, 0.5) --just scale x to ratio
    g.draw(content.images.slowmotion, -content.images.slowmotion_hw, -content.images.slowmotion_hh)
    g.pop()
end

function SlowMotion:always()
    if self.state == 'idle' then
        flatmoon.engine.dtfactor = 1 --set to normal

        self.remainTime = self.remainTime + self.restoreSpeed*dt
        if self.remainTime > self.maxTime then self.remainTime = self.maxTime end

    elseif self.state == 'active' then
        flatmoon.engine.dtfactor = self.timeFactor --active factor

        self.remainTime = self.remainTime - dt/flatmoon.engine.dtfactor --the real delta time
        if self.remainTime < 0 then
            self.remainTime = 0
            self.state = 'idle'
        end
    end
end

function SlowMotion:toggle()
    if self.state == 'idle' then
        self.state = 'active'
    elseif self.state == 'active' then
        self.state = 'idle'
    end
end