
require 'covere.scenes.play.Bullet'

Soldier = {}
Soldier.__index = Soldier

function Soldier.new(x, y, speed)
    local self = Enemy.new(x, y, speed):extend(Soldier)

    self.tags:add('soldier')

    self.r = 15
    self.damage = 2

    self.fireRange = 300
    self.fireSpeed = 200
    self.fireDelay = 3

    self:doGun()

    return self
end

function Soldier.getAll()
    return Thing.getAll('enemy')
end

function Soldier:draw()
    g.push()
    g.translate(self.x, self.y)
    g.scale(self.r/content.images.soldier_r)
    g.rotate(self.angle)
    g.setColor(255, 0, 0, 255)
    g.draw(content.images.soldier, -content.images.soldier_hw, -content.images.soldier_hh)
    g.pop()
end

function Soldier:processMove()
    self.angle = math.atan2(Core.instance().y - self.y, Core.instance().x - self.x)
    self.x = self.x + math.cos(self.angle)*self.speed*dt
    self.y = self.y + math.sin(self.angle)*self.speed*dt
end

function Soldier:doGun()
    self:seq(function ()
        while self:alive() do
            local dist = math.sqrt(math.pow(self.x - Core.instance().x, 2), math.pow(self.y - Core.instance().y, 2))

            --appeare first
            if self.x > 0 and self.x < 960 and self.y > 0 and self.y < 640 and dist <= self.fireRange then
                Bullet.new('core', self.x, self.y, self.angle, self.fireSpeed, self.damage, false)
                --effecting
                love.audio.newSource(content.sounds.soldierfire):play()

                wait(self.fireDelay + math.random()*self.fireDelay)
            end

            yield()
        end
    end)
end