
TripleShot = {}
TripleShot.__index = TripleShot

function TripleShot.new(x, y, fallSpeed, lifeTime)
    local self = Item.new(x, y, fallSpeed, lifeTime):extend(TripleShot)

    self.tags:add('tripleshot')

    return self
end

function TripleShot.getAll(...)
    return Thing.getAll('tripleshot', ...)
end

function TripleShot:draw()
    g.push()
    g.translate(self.x, self.y)
    g.scale(self.r/content.images.tripleshot_r)
    g.setColor(50, 255, 255, 255*self.remainTime/self.lifeTime)
    g.draw(content.images.tripleshot, -content.images.tripleshot_hw, -content.images.tripleshot_hh)
    g.pop()
end

function TripleShot:active()
    Item.active(self)

    self.oldFire = Gun.instance().fire
    local of = self.oldFire
    --two self different
    Gun.instance().fire = function (self)
        of(self) --one shot of old fire

        --two more
        local fx, fy = self.x + self.r*math.cos(self.angle), self.y + self.r*math.sin(self.angle)
        Bullet.new('enemy', fx, fy, self.angle - math.pi/8, self.fireSpeed, 1, false)
        Bullet.new('enemy', fx, fy, self.angle + math.pi/8, self.fireSpeed, 1, false)
    end
end

function TripleShot:deactive()
    Gun.instance().fire = nil

    Item.deactive(self)
end