assert(flatmoon and flatmoon.engine, 'flatmoon.engine must be required before flatmoon.tweener', 4)
flatmoon.tweener = {}

local assert = flatmoon.utils.assert

--============================================================--

tweener = flatmoon.tweener

local easings

--a simple tweener here
--must put in a parDo
function tweener.inTime (time, func, ensure)
    assert(tonumber(time), 'inTime expects a number for 1th arg')
    assert(type(func) == 'function', 'inTime expects a function for 2th arg')
    time = tonumber(time)

    if ensure and not ensure() then return end

    local total = time
    local remain = total
    while remain > 0 do
        remain = remain - dt
        if remain < 0 then remain = 0 end
        local ratio = remain / total

        func(1 - ratio) -- 0 .... 1

        yield()
        if ensure and not ensure() then break end
    end
end

--tweener here
--must put in a parDo
function tweener.tween(thing, time, endTable, startTable, easing, ensure)
    assert(type(thing) == 'table', 'tween expects a table for 1th arg')
    assert(tonumber(time), 'tween expects a number for 2th arg')
    assert(type(endTable) == 'table', 'tween expects a table for 3th arg')
    time = tonumber(time)

    if not startTable then
        startTable = {}
    else
        assert(type(startTable) == 'table', 'tween expects a table (or a nil) for 4th arg')
    end
    if not easing then easing = 'linear' end
    assert(easings[easing], 'tween expects a correct name of ease function for 4th arg')

    local dttb = {} --delta of start and end
    local dive
    dive = function (etb, stb, ttb)
        for k, v in pairs(etb) do
            if type(ttb[k]) == 'table' then
                if not stb[k] then stb[k] = {} end
                dive(etb[k], stb[k], ttb[k])
            else
                assert(tonumber(ttb[k]), 'tweener expects all table field is number')
                assert(tonumber(etb[k]), 'tweener expects all table field is number')

                if stb[k] then
                    assert(tonumber(stb[k]), 'tweener expects all table field is number') 
                else
                    stb[k] = ttb[k]
                end

                dttb[k] = etb[k] - stb[k] --now it is delta
            end
        end
    end
    dive(endTable, startTable, thing)

    local f = function (ratio)
        --linear
        local dive2
        dive2 = function (etb, stb, ttb)
            for k, v in pairs(etb) do
                if type(ttb[k]) == 'table' then
                    dive2(etb[k], stb[k], ttb[k])
                else
                    ttb[k] = easings[easing](stb[k], dttb[k], ratio)
                end
            end
        end
        dive2(endTable, startTable, thing)
    end
    
    tweener.inTime(time, f, ensure)
end

easings = {
    linear = function (start, delta, ratio)
        return start + delta*ratio
    end,
    elastic = function (start, delta, ratio)
        local r2 = ratio*ratio
        local r3 = r2*ratio
        return start + delta*(56*r3*r2 + -175*r2*r2 + 200*r3 + -100*r2 + 20*ratio)
    end,
    bounce = function (b, c, ratio)
        local t = ratio
        if t < 1 / 2.75 then return c * (7.5625 * t * t) + b end
        if t < 2 / 2.75 then
            t = t - (1.5 / 2.75)
            return c * (7.5625 * t * t + 0.75) + b
        elseif t < 2.5 / 2.75 then
            t = t - (2.25 / 2.75)
            return c * (7.5625 * t * t + 0.9375) + b
        end
        t = t - (2.625 / 2.75)
        return c * (7.5625 * t * t + 0.984375) + b
    end
}